package com.openexchange.oauth.provider.soap;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebResult;
import javax.jws.WebService;
import javax.xml.bind.annotation.XmlSeeAlso;
import javax.xml.ws.Action;
import javax.xml.ws.FaultAction;
import javax.xml.ws.RequestWrapper;
import javax.xml.ws.ResponseWrapper;

/**
 * This class was generated by Apache CXF 2.6.16
 * 2015-04-14T10:21:14.857+02:00
 * Generated source version: 2.6.16
 *
 */
@WebService(targetNamespace = "http://soap.provider.oauth.openexchange.com", name = "OAuthClientServicePortType")
@XmlSeeAlso({ObjectFactory.class})
public interface OAuthClientServicePortType {

    @WebResult(name = "clients", targetNamespace = "http://soap.provider.oauth.openexchange.com")
    @Action(input = "urn:listClients", output = "urn:listClientsResponse", fault = {@FaultAction(className = OAuthClientServiceException.class, value = "urn:listClientsException")})
    @RequestWrapper(localName = "listClients", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.ListClients")
    @WebMethod(action = "urn:listClients")
    @ResponseWrapper(localName = "listClientsResponse", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.ListClientsResponse")
    public java.util.List<com.openexchange.oauth.provider.soap.ClientListData> listClients(
        @WebParam(name = "contextGroup", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        java.lang.String contextGroup,
        @WebParam(name = "credentials", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        Credentials credentials
    ) throws OAuthClientServiceException;

    @WebResult(name = "return", targetNamespace = "http://soap.provider.oauth.openexchange.com")
    @Action(input = "urn:getClientById", output = "urn:getClientByIdResponse", fault = {@FaultAction(className = OAuthClientServiceException.class, value = "urn:getClientByIdException")})
    @RequestWrapper(localName = "getClientById", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.GetClientById")
    @WebMethod(action = "urn:getClientById")
    @ResponseWrapper(localName = "getClientByIdResponse", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.GetClientByIdResponse")
    public com.openexchange.oauth.provider.soap.Client getClientById(
        @WebParam(name = "clientId", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        java.lang.String clientId,
        @WebParam(name = "credentials", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        Credentials credentials
    ) throws OAuthClientServiceException;

    @WebResult(name = "return", targetNamespace = "http://soap.provider.oauth.openexchange.com")
    @Action(input = "urn:registerClient", output = "urn:registerClientResponse", fault = {@FaultAction(className = OAuthClientServiceException.class, value = "urn:registerClientException")})
    @RequestWrapper(localName = "registerClient", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.RegisterClient")
    @WebMethod(action = "urn:registerClient")
    @ResponseWrapper(localName = "registerClientResponse", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.RegisterClientResponse")
    public com.openexchange.oauth.provider.soap.Client registerClient(
        @WebParam(name = "contextGroup", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        java.lang.String contextGroup,
        @WebParam(name = "clientData", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        com.openexchange.oauth.provider.soap.ClientData clientData,
        @WebParam(name = "credentials", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        Credentials credentials
    ) throws OAuthClientServiceException;

    @WebResult(name = "return", targetNamespace = "http://soap.provider.oauth.openexchange.com")
    @Action(input = "urn:updateClient", output = "urn:updateClientResponse", fault = {@FaultAction(className = OAuthClientServiceException.class, value = "urn:updateClientException")})
    @RequestWrapper(localName = "updateClient", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.UpdateClient")
    @WebMethod(action = "urn:updateClient")
    @ResponseWrapper(localName = "updateClientResponse", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.UpdateClientResponse")
    public com.openexchange.oauth.provider.soap.Client updateClient(
        @WebParam(name = "clientId", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        java.lang.String clientId,
        @WebParam(name = "clientData", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        com.openexchange.oauth.provider.soap.ClientData clientData,
        @WebParam(name = "credentials", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        Credentials credentials
    ) throws OAuthClientServiceException;

    @WebResult(name = "return", targetNamespace = "http://soap.provider.oauth.openexchange.com")
    @Action(input = "urn:unregisterClient", output = "urn:unregisterClientResponse", fault = {@FaultAction(className = OAuthClientServiceException.class, value = "urn:unregisterClientException")})
    @RequestWrapper(localName = "unregisterClient", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.UnregisterClient")
    @WebMethod(action = "urn:unregisterClient")
    @ResponseWrapper(localName = "unregisterClientResponse", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.UnregisterClientResponse")
    public boolean unregisterClient(
        @WebParam(name = "clientId", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        java.lang.String clientId,
        @WebParam(name = "credentials", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        Credentials credentials
    ) throws OAuthClientServiceException;

    @WebResult(name = "client", targetNamespace = "http://soap.provider.oauth.openexchange.com")
    @Action(input = "urn:revokeClientSecret", output = "urn:revokeClientSecretResponse", fault = {@FaultAction(className = OAuthClientServiceException.class, value = "urn:revokeClientSecretException")})
    @RequestWrapper(localName = "revokeClientSecret", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.RevokeClientSecret")
    @WebMethod(action = "urn:revokeClientSecret")
    @ResponseWrapper(localName = "revokeClientSecretResponse", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.RevokeClientSecretResponse")
    public com.openexchange.oauth.provider.soap.Client revokeClientSecret(
        @WebParam(name = "clientId", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        java.lang.String clientId,
        @WebParam(name = "credentials", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        Credentials credentials
    ) throws OAuthClientServiceException;

    @WebResult(name = "return", targetNamespace = "http://soap.provider.oauth.openexchange.com")
    @Action(input = "urn:enableClient", output = "urn:enableClientResponse", fault = {@FaultAction(className = OAuthClientServiceException.class, value = "urn:enableClientClientException")})
    @RequestWrapper(localName = "enableClient", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.EnableClient")
    @WebMethod(action = "urn:enableClient")
    @ResponseWrapper(localName = "enableClientResponse", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.EnableClientResponse")
    public boolean enableClient(
        @WebParam(name = "clientId", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        java.lang.String clientId,
        @WebParam(name = "credentials", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        Credentials credentials
    ) throws OAuthClientServiceException;

    @WebResult(name = "return", targetNamespace = "http://soap.provider.oauth.openexchange.com")
    @Action(input = "urn:disableClient", output = "urn:disableClientResponse", fault = {@FaultAction(className = OAuthClientServiceException.class, value = "urn:disableClientException")})
    @RequestWrapper(localName = "disableClient", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.DisableClient")
    @WebMethod(action = "urn:disableClient")
    @ResponseWrapper(localName = "disableClientResponse", targetNamespace = "http://soap.provider.oauth.openexchange.com", className = "com.openexchange.oauth.provider.soap.DisableClientResponse")
    public boolean disableClient(
        @WebParam(name = "clientId", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        java.lang.String clientId,
        @WebParam(name = "credentials", targetNamespace = "http://soap.provider.oauth.openexchange.com")
        Credentials credentials
    ) throws OAuthClientServiceException;
}
